/*
    Miguel Ramirez, Nir Lipovetzky, Hector Geffner
    C^3: A planner for the sequential, satisficing track of the IPC-6
    Copyright (C) 2008  

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef __NFF_DFS_NODE__
#define __NFF_DFS_NODE__

#include "nff.hxx"
#include "nff_state.hxx"
#include "PDDL.hxx"

namespace NFF
{

class Dfs_Node
{
public:
	Dfs_Node();  
	~Dfs_Node();

	Dfs_Node* 			successor( unsigned op );
	Dfs_Node*			successor( unsigned op, Support& commit );
	Dfs_Node*               	relaxed_successor( unsigned op );
	void                    	apply_commit( unsigned op, Support& commit );
	static Dfs_Node*		root();
	bool				operator==( Dfs_Node& o )
	{
		return s->operator==(*(o.s));
	}

	// I leave them public for ease of access
	State*				s;	// state
	float				gn;	// accumulated cost
	float				hn;	// heuristic value
	float				fn;	// evaluation function
	Dfs_Node*			parent;
	unsigned			op;	// operator
	PDDL::Fluent_Set*		Locked;
	PDDL::Fluent_Set*		Waiting;
	PDDL::Fluent_Set*		Landmarks;
	Support_List			Pending;

protected:

	static	PDDL::Task&	sm_task;

};

}

#endif // nff_dfs_node.hxx
